// hpmodel_json.cpp

#include "HPModel.h"
#include <iostream>
#include <fstream>

int main()
{
    // Create an HPModel instance with a given sequence
    std::string sequence = "pppp";
    HPModel model(sequence);

    try
    {
        model.fold(UP);
        model.fold(UP);
        model.fold(UP);
    }
    catch (const std::exception& e)
    {
        std::cerr << "Error folding model: " << e.what() << std::endl;
        return 1;
    }

    // Serialize points to JSON
    std::string jsonOutput = model.pointsToJson();

    // Write JSON to file
    std::ofstream outFile("hpmodel_output.json");
    if (outFile.is_open())
    {
        outFile << jsonOutput;
        outFile.close();
        std::cout << "JSON data written to hpmodel_output.json" << std::endl;
    }
    else
    {
        std::cerr << "Failed to write JSON data to file" << std::endl;
        return 1;
    }

    return 0;
}